/***************************************************
 * 작성자 : 이종우
 * 작성일 : 2014.09.25
 * 수정일 : 2014.10.15
 * 설 명 : contents(sitemap page) 에서의 key event 처리 구현
***************************************************/

// key code
var KEY_BACK	= "8";
var KEY_BACK_TV = BackKey;
var KEY_ENTER	= enterKey;
var KEY_LEFT	= leftKey;
var KEY_UP		= upKey;
var KEY_RIGHT	= rightKey;
var KEY_DOWN	= downKey;

var backFocus 		= false;
var menuFocus 		= false;
var itemFocus 		= false;
var scrollFocus		= false;

var INDEX_SEARCH 	= 0;
var MAX_ITEM;

var menuIndex = 1; // nth-child
var itemIndex = 0; // eq

var OFFSET_TOP		= 331;
var OFFSET_BOTTOM	= 850;
var ITEM_HEIGHT		= 40;
var SCROLL_INTERVAL_TIME	= 100;

// add, jongwoo_lee, 20141001, mouse no event when key event flag
var isKeyDown = 0;

var isScrolling = false;

var isScrollDirection	= true;	 // true : up / false : down

var isScrollKeyDown		= false; // down : true / up : false

var scrollUpTimeout;
var scrollDownTimeout;

var intervalId;

$(document).ready(function() {	
	// 옵션 처리 부분 추가, maverick 20140924
	getCheckOptionSitemapProcess();
	
	MAX_ITEM = $(".list ul li a").size();
	$(".lnb-2 ul li:nth-child(1) a span").attr("class","point");
	
	// add, jongwoo_lee, 20141008
	// back 처리를 위하여 인덱스 값 local storage 에 저장
	if(window.localStorage.getItem("sitemap_itemIndex") >= 0) {
		itemFocus = true;
		itemIndex = window.localStorage.getItem("sitemap_itemIndex");
		$(".list ul li a").eq(itemIndex).focus();
	}
	else {
		menuFocus = true;
		$(".lnb-2 ul li:nth-child(1) a").focus();
	}

	
	$(".search")
	.mouseover(function() {
		// search bar 내려올 시 에 대한 MRCU 처리
		// add, jongwoo_lee, 20141103
		// searchCloseFlag 는 search_key.js 에 정의
		if(searchCloseFlag == true){
			if(isKeyDown > 0) {
				isKeyDown = 0;
				return false;
			}
			
			backFocus = false;
			itemFocus = false;
			menuFocus = false;
			scrollFocus = false;
			
			$(".search").focus();
		}
	})
	.mouseout(function() {
		if(searchCloseFlag == true){
			$('.sitemap-wrap').focus();
		}
	})
	.on("keydown", function(e) {
		isKeyDown = 1;
		if(e.keyCode == KEY_LEFT) {
			//console.log("search key left");
			leftKeyEvent();
		}
		if(e.keyCode == KEY_UP) {
			//console.log("search key up");
			upKeyEvent();
		}
		if(e.keyCode == KEY_RIGHT) {
			//console.log("search key right");
			rightKeyEvent();
		}
		if(e.keyCode == KEY_DOWN) {
			//console.log("search key down");
			downKeyEvent();
		}
		if(e.keyCode == KEY_ENTER) {
			//console.log("search key enter");
			enterKeyEvent();
		}
		if(e.keyCode == KEY_BACK || e.keyCode == KEY_BACK_TV) {
			//console.log("search key back");
			backKeyEvent();
		}
	});
	
	$(".btn-back")
	.mouseover(function() {
		if(searchCloseFlag == true){
			if(isKeyDown > 0) {
				isKeyDown = 0;
				return false;
			}
			
			itemFocus = false;
			menuFocus = false;
			scrollFocus = false;
			backFocus = true;
			
			$(".btn-back").focus();
		}
	})
	.mouseout(function() {
		if(searchCloseFlag == true){
			$('.sitemap-wrap').focus();
		}
	})
	.on("click", function() {
		backKeyEvent();
	})
	.on("keydown", function(e) {
		isKeyDown = 1;
		if(e.keyCode == KEY_LEFT) {
			//console.log("btn-back key left");
			leftKeyEvent();
		}
		if(e.keyCode == KEY_UP) {
			//console.log("back-back key up");
			upKeyEvent();
		}
		if(e.keyCode == KEY_RIGHT) {
			//console.log("back-back key right");
			rightKeyEvent();
		}
		if(e.keyCode == KEY_DOWN) {
			//console.log("back-back key down");
			downKeyEvent();
		}
		if(e.keyCode == KEY_ENTER) {
			//console.log("back-back key enter");
			enterKeyEvent();
		}
		if(e.keyCode == KEY_BACK || e.keyCode == KEY_BACK_TV) {
			//console.log("back-back key back");
			backKeyEvent();
		}
	});
	
	$(".lnb-2 ul li a")
	.mouseover(function() {
		if(searchCloseFlag == true){
			if(isKeyDown > 0) {
				isKeyDown = 0;
				return false;
			}
			
			backFocus = false;
			itemFocus = false;
			scrollFocus = false;
			menuFocus = true;
			
			menuIndex = $(".lnb-2 ul li a").index($(this)) + 1;
			//console.log("menu mouse over .. ( " + menuIndex + " )");
			$(".lnb-2 ul li:nth-child(" + menuIndex + ")").children('a').focus();
		}
	})
	.mouseout(function() {
		if(searchCloseFlag == true){
			$('.sitemap-wrap').focus();
		}
	})
	.on("keydown", function(e) {
		isKeyDown = 1;
		if(e.keyCode == KEY_LEFT) {
			//console.log("ul li key left");
			leftKeyEvent();
		}
		if(e.keyCode == KEY_UP) {
			//console.log("ul li key up");
			upKeyEvent();
		}
		if(e.keyCode == KEY_RIGHT) {
			//console.log("ul li key right");
			rightKeyEvent();
		}
		if(e.keyCode == KEY_DOWN) {
			//console.log("ul li key down");
			downKeyEvent();
		}
		if(e.keyCode == KEY_ENTER) {
			//console.log("ul li key enter");
			var currentMenuIndex = $(".lnb-2 ul li a").index($(this)) + 1;
			if(currentMenuIndex == 1) {
				e.preventDefault();	
				
				backFocus = false;
				menuFocus = false;
				scrollFocus = false;
				itemFocus = true;

				$(".list ul li a").eq(itemIndex).focus();
			}
		}
		if(e.keyCode == KEY_BACK || e.keyCode == KEY_BACK_TV) {
			//console.log("ul li key back");
			backKeyEvent();
		}
	});
	
	$(".list ul li a")
	.mouseover(function() {
		if(searchCloseFlag == true && isScrolling == false){
			if(isKeyDown > 0) {
				isKeyDown = 0;
				return false;
			}
			
			backFocus = false;
			menuFocus = false;
			scrollFocus = false;
			itemFocus = true;
			
			itemIndex = $(".list ul li a").index($(this));
			//$(".list ul li a").eq(itemIndex).get(0).scrollIntoView(false);
			$(".list ul li a").eq(itemIndex).focus();
			window.localStorage.setItem("sitemap_itemIndex", itemIndex);
		}
	})
	.mouseout(function() {
		if(searchCloseFlag == true && isScrolling == false){
			$('.sitemap-wrap').focus();
		}
	})
	.on("keydown", function(e) {
		isKeyDown = 1;
		if(e.keyCode == KEY_LEFT) {
			//console.log("ul li key left");
			leftKeyEvent();
		}
		if(e.keyCode == KEY_UP) {
			//console.log("ul li key up");
			upKeyEvent(e);
		}
		if(e.keyCode == KEY_RIGHT) {
			//console.log("ul li key right");
			rightKeyEvent();
		}
		if(e.keyCode == KEY_DOWN) {
			//console.log("ul li key down");
			downKeyEvent(e);
		}
		if(e.keyCode == KEY_ENTER) {
			//console.log("ul li key enter");
			enterKeyEvent();
		}
		if(e.keyCode == KEY_BACK || e.keyCode == KEY_BACK_TV) {
			//console.log("ul li key back");
			backKeyEvent();
		}
	});
	
	/*************** Scroll Up & Down Button Event ***********************/
	// up
	$(".arrow-up")
	.mouseover(function() {
		if(searchCloseFlag == true && isScrolling == false){
			backFocus = false;
			menuFocus = false;
			itemFocus = false;
			scrollFocus = true;	
			isScrollDirection = true;
			
			isScrollButtonDown = false;
			
			$(".arrow-up").focus();
		}
	})
	.mouseout(function() {
		if(searchCloseFlag == true && isScrolling == false){
			$('.sitemap-wrap').focus();
		}
	})
	.mousedown(function(){
		intervalId = setInterval(scrollUpEvent, SCROLL_INTERVAL_TIME);
	})
	.mouseup(function(){
		clearInterval(intervalId);
	})
	.on("keydown", function(e) {
		isKeyDown = 1;
		if(e.keyCode == KEY_LEFT) {
			leftKeyEvent();
		}
		if(e.keyCode == KEY_UP) {
			upKeyEvent(e);
		}
		if(e.keyCode == KEY_RIGHT) {
			rightKeyEvent();
		}
		if(e.keyCode == KEY_DOWN) {
			downKeyEvent(e);
		}
		if(e.keyCode == KEY_ENTER) {
			if(isScrollKeyDown == false) { 
				isScrollKeyDown = true;
				enterKeyEvnet();
			}
		}
		if(e.keyCode == KEY_BACK || e.keyCode == KEY_BACK_TV) {
			backKeyEvent();
		}
	})
	.on("keyup", function(e) {
		isKeyDown = 1;
		if(e.keyCode == KEY_ENTER) {
			isScrollKeyDown = false;
			clearInterval(intervalId);
		}
	});
	
	////down
	$(".arrow-down")
	.mouseover(function() {
		if(searchCloseFlag == true && isScrolling == false){
			backFocus = false;
			menuFocus = false;
			itemFocus = false;
			scrollFocus = true;	
			isScrollDirection = false;
			
			isScrollButtonDown = false;
			
			$(".arrow-down").focus();
		}
	})
	.mouseout(function() {
		if(searchCloseFlag == true && isScrolling == false){
			$('.sitemap-wrap').focus();
		}
	})
	.mousedown(function(){
		intervalId = setInterval(scrollDownEvent, SCROLL_INTERVAL_TIME);
	})
	.mouseup(function(){
		clearInterval(intervalId);
	})
	.on("keydown", function(e) {
		isKeyDown = 1;
		if(e.keyCode == KEY_LEFT) {
			leftKeyEvent();
		}
		if(e.keyCode == KEY_UP) {
			upKeyEvent(e);
		}
		if(e.keyCode == KEY_RIGHT) {
			rightKeyEvent();
		}
		if(e.keyCode == KEY_DOWN) {
			downKeyEvent(e);
		}
		if(e.keyCode == KEY_ENTER) {
			if(isScrollKeyDown == false) {
				isScrollKeyDown = true;
				enterKeyEvnet();
			}
		}
		if(e.keyCode == KEY_BACK || e.keyCode == KEY_BACK_TV) {
			backKeyEvent();
		}
	})
	.on("keyup", function(e) {
		isKeyDown = 1;
		if(e.keyCode == KEY_ENTER) {
			isScrollKeyDown = false;
			clearInterval(intervalId);
		}
	});
	
	/*********************************************************************************/

	// add, jongwoo_lee, 20141105, 스크롤 중일때 마우스로 아이템 선택 못하게 막음.
	$(".list").scroll(function() {
		clearTimeout($.data(this, 'scrollTimer'));
		$.data(this, 'scrollTimer', setTimeout(function() {
			// do something
			isScrolling = false;
		}, SCROLL_TIMEOUT));
		isScrolling = true;
	});
	
	// 문스톤 형식으로 변형
//	$('.sitemap-wrap').focus(function() {
		$('.sitemap-wrap').on("keydown", function(e) {
			if(backFocus == false && menuFocus == false && itemFocus == false && scrollFocus == false) {
				$(".search").focus();
			}
			else if(backFocus == true) {
				$(".btn-back").focus();
			}
			else if(menuFocus == true) {
				$(".lnb-2 ul li:nth-child(" + menuIndex + ") a").focus();
			}
			else if(itemFocus == true) {
				$(".list ul li a").eq(itemIndex).focus();
			}
			else if(scrollFocus == true) {
				// scroll arrow up
				if(isScrollDirection == true) {
					$(".arrow-up").focus();
				}
				// scroll arrow down
				else {
					$(".arrow-down").focus();
				}
			}
		});
//	});
});

function leftKeyEvent() {
	//console.log("left key");
	if(backFocus == false && menuFocus == false && itemFocus == false && scrollFocus == false) {
		backFocus = true;
		$(".btn-back").focus();
	}
	else if(backFocus == true) { }
	else if(menuFocus == true) {
		menuFocus = false;
		backFocus = true;
		$(".btn-back").focus();
	}
	else if(itemFocus == true) {
		itemFocus = false;
		menuFocus = true;
		$(".lnb-2 ul li:nth-child(" + menuIndex + ") a").focus();
	}
	else if(scrollFocus == true) { 
		scrollFocus = false;
		isScrollDirection = true;
		itemFocus = true;
		
		$(".list ul li a").eq(itemIndex).focus();
		window.localStorage.setItem("sitemap_itemIndex", itemIndex);
	}
}

function rightKeyEvent() {
	if(backFocus == true) {
		backFocus = false;
		menuFocus = true;
		$(".lnb-2 ul li:nth-child(" + menuIndex + ") a").focus();
	}
	else if(menuFocus == true) {
		menuFocus = false;
		itemFocus = true;
		$(".list ul li a").eq(itemIndex).focus();
		window.localStorage.setItem("sitemap_itemIndex", itemIndex);
	}
	else if(itemFocus == true) {
		itemFocus = false;
		scrollFocus = true;
		isScrollDirection = true;
		
		$('.arrow-up').focus();
	}
}

function upKeyEvent(e) {
	//console.log("up key");
	if(backFocus == false && menuFocus == false && itemFocus == false && scrollFocus == false) {
		menuFocus = true;
		
		$(".search").focus();
	}
	else if(backFocus == true) {
		backFocus = false;
		
		$(".search").focus();
	}
	else if(menuFocus == true) {
		//console.log("menu up");
		
		if(menuIndex == 1) {
			menuFocus = false;
			
			$(".search").focus();
		}
		else if(menuIndex == 2) {
			$(".lnb-2 ul li:nth-child(1) a").focus();
			menuIndex = 1;
		}
	}
	else if(itemFocus == true) {
		itemIndex--;
		if(itemIndex < 0) {
			itemIndex = 0;
		}
				
//		var liSize = $(e.target).parents('ul').children('li').length;
		var liIndex = $(e.target).parents('ul').children('li').index($(e.target).parent('li'));
		
		var offset = $(e.target).offset();
		if(itemIndex > 0 && liIndex == 0 && offset.top < OFFSET_TOP) { 
			$(".list ul li a").eq(itemIndex).get(0).scrollIntoView(true);
		}

		$(".list ul li a").eq(itemIndex).focus();
		window.localStorage.setItem("sitemap_itemIndex", itemIndex);
	}
	else if(scrollFocus == true) { 
		isScrollDirection = true;
		$('.arrow-up').focus();
	}
}

function downKeyEvent(e) {
	if(backFocus == false && menuFocus == false && itemFocus == false && scrollFocus == false) {
		menuFocus = true;

		$(".lnb-2 ul li:nth-child(1) a").focus();
		menuIndex = 1;
	}
	else if(backFocus == true) {
		backFocus = false;
		menuFocus = true;
		
		$(".lnb-2 ul li:nth-child(1) a").focus();
		menuIndex = 1;
	}
	else if(menuFocus == true) {
		backFocus = false;
		itemFocus = false;
		
		if(menuIndex == 1) {
			$(".lnb-2 ul li:nth-child(2) a").focus();
			menuIndex = 2;
		}
	}
	else if(itemFocus == true) {
		itemIndex++;
		
		if(itemIndex >= MAX_ITEM-1) {
			itemIndex = MAX_ITEM-1; 
		}
		
		var liSize = $(e.target).parents('ul').children('li').length;
		var liLimit = liSize - 1;
		var liIndex = $(e.target).parents('ul').children('li').index($(e.target).parent('li'));
		
		var offset = $(e.target).offset();
	
		if(liIndex == liLimit && offset.top > OFFSET_BOTTOM) { 
			$(".list ul li a").eq(itemIndex).get(0).scrollIntoView(false); 
		}

		$(".list ul li a").eq(itemIndex).focus();
		window.localStorage.setItem("sitemap_itemIndex", itemIndex);
		
		//console.log($(".list")[0].scrollTop);
	}
	else if(scrollFocus == true) {
		isScrollDirection = false;
		$('.arrow-down').focus();
	}
}

function enterKeyEvnet() {
	//console.log("enter key");
	if(scrollFocus == true) {
		//console.log("------------------------- [enter]!!! ");
		// scroll arrow up
		if(isScrollDirection == true) {
			intervalId = setInterval(scrollUpEvent, SCROLL_INTERVAL_TIME);
		}
		// scroll arrow down
		else {
			intervalId = setInterval(scrollDownEvent, SCROLL_INTERVAL_TIME);
		}
	}
}

function backKeyEvent() {
	//console.log("back key");
	backkeyPageProcess();
}

function scrollUpEvent() {
	$(".list").scrollTop($(".list").scrollTop() - ITEM_HEIGHT);
}

function scrollDownEvent() {
	$(".list").scrollTop($(".list").scrollTop() + ITEM_HEIGHT);
}
